//Right now only the two server slots are supported, adding any beyond the second one will be ignored.
url['users'] = new Array()
url['users'][0] = 'http://www.vo-wiki.com/userlist/parser.php?version=2';
url['users'][1] = 'http://www.upsidedownturtle.com/userlist/parser.php?version=2';

url['serverNames'] = new Array()
url['serverNames'][0] = "vo-wiki.com";
url['serverNames'][1] = "upsidedownturtle.com";

var switchBackWait = 30 * 60 * 1000; //Return to primary server after x miliseconds (minutes * seconds * 1000).
var switchBackTime = 0 // Do not edit, overwritten by script. The point in time that the script will retry using the primary server.
var useServer = 0; //Which server is currently being used.
var runImmediate = true;	//Whether or not to run the ajax request immediately after starting the request, rather than waiting one
							//minute for the periodical to execute the request. Switches to false so that when both servers can not
							//be connected to, it won't constantly keep trying non-stop.

var lastUpdate = 0;		//Overwritten by script. When the userlist was last retrieved, if the data is 5 minutes old, then it will not
						//send growl notifications and will get a new set of usercount data.
var d = new Date();

var second = 1000	// One second in milliseconds. unused?
var minute = 60*second // One minute in milliseconds. unused?

var updateInterval = 60 * 1000 //How often to update, expressed in milliseconds.
var updateTimer;
var ajax = new Ajax(url['users'][useServer], {
		method: 'get',
		onComplete: requestComplete,
		onFailure: function(received){requestFailed("userlist",received)},
		timeout: 10000,
		onTimeout: function(received){requestFailed("userlist","timeout")}
	});

//Update the ajax objects, used whenever useServer changes.
function updateAjaxRequests(){
	ajax = new Ajax(url['users'][useServer], {
		method: 'get',
		onComplete: requestComplete,
		onFailure: function(received){requestFailed("userlist",received)},
		timeout: 10000,
		onTimeout: function(){requestFailed("userlist","timeout")}
	});
	
	ajax2 = new Ajax(url['guilds'][useServer], {
		method: 'get',
		onComplete: guildRequestComplete,
		onFailure: function(received){requestFailed("guildlist",received)}
	});
	
	ajax3 = new Ajax(url['count'][useServer], {
		method: 'get',
		onComplete: countRequestComplete,
		onFailure: function(received){requestFailed("usercount",received)}
	});

}

function startRequest(){		
	updateTimer = (function(){makeRequest()}).periodical(updateInterval);
	if(runImmediate){
		makeRequest();
		makeGuildRequest();
	}
}

function stopRequest(){
	stopIndicatorPulse()
	$clear(updateTimer);
}

function makeRequest(){
	if(d.getTime() < switchBackTime || useServer == 0){ //if current time exceeds switchbacktime, return useserver to 0, and refresh the ajax scripts, stop the current timer, and start a new one. Maybe force a usercount refresh
		stopIndicatorPulse()
		startIndicatorPulse()
		sendDebug("Fetching user list.")
		ajax.request();
	} else {
		useServer = 0;
		updateAjaxRequests();
		stopRequest();
		startRequest();
		runImmediate = true;	//Order is important, not meant to make current startRequest
								//immediate, just the next one when it switches to backup server
	}
}

var nationUpdateTimer
function requestComplete(received){
	//I use a delay of 500ms so that the opacity changes are fluid,
	//without it the userlist parsing can making the transition
	//less fluid.
	stopIndicatorPulse()
	sendDebug("User list fetched.")
	if($('friendWindow').style.opacity == 0){
		(function(){contentOpacityChange.start(1);}).delay(250)
	}
	(function(){errorOpacityChange.start(0);}).delay(510);
	
	(function(){logoOpacityChange.start(0);}).delay(250);
	
	assembleNations(received);
	
	createNationDisplay()

	//If data is less than 5 minutes old...
	if(d.getTime() - lastUpdate < 5 * 60 * 1000){
		sendFriendlyNotification()
	} else {
		requestUserCountList();
	}
		
	lastUpdate = d.getTime();
}

function requestFailed(what,received){
	if(received != "timeout"){
		sendDebug(what + " failed to load... " + received.status);
		if(what == "userlist"){
			switch(received.status){
				default: tryOtherServer(); break;
			}
		}
	} else {
		sendDebug(what + " failed to load... (timeout)");
		tryOtherServer();
	}
	
}
var attemptedOtherServer = false;
function tryOtherServer(){
	sendDebug("Attempting server switch do to failure to connect");
	if(useServer == 0){
		sendDebug("Switching to backup server...");
		showWarning("minor","The primary server can not be reached, using back up server. This may result in reduced functionality.");
		useServer++
		updateAjaxRequests();
		stopRequest();
		startRequest();
		attemptedOtherServer = true;
		switchBackTime = d.getTime() + switchBackWait;
	} else if(attemptedOtherServer && useServer == 1){
		sendDebug("Switching to primary server...");
		showError();
		runImmediate = false;
		useServer = 0;
		attemptedOtherServer = false;
		updateAjaxRequests();
		stopRequest();
		startRequest();
		
	}
	sendDebug("Server switched.");
}

function showError(){
	(function(){errorOpacityChange.start(1);}).delay(500);
	(function(){logoOpacityChange.start(0);}).delay(500);
}

function retryConnection(){
	errorOpacityChange.start(0);
	
	runImmediate = true;
	useServer = 0;
	updateAjaxRequests();
	stopRequest();
	startRequest();
}

function showWarning(severity,content){
	/*
	if(severity = "none"){$('warning').style.opacity = 0;} else {$('warning').style.opacity = 1;}
	if(severity = "minor"){$('warning').style.color = "#ff0";}
	if(severity = "critical"){$('warning').style.color = "#f00";}*/
}