//Spark graph, the graph in the lower left corner.

var userCount = new Array();
userCount.push(0);
var userCountTemp = new Array();

var sparkResolution = 8; //Minutes per spread
var sparkGap = 2;	//How many pixels gap between info points, makes the
					//graph less accurate, but look smoother.

//Total points shown: sparkMaxWidth / sparkGap
//Minutes per pixel: sparkResolution
//Minutes per point: sparkResolution * sparkGap
//Total time shwon: sparkResolution * sparkMaxWidth

var sparkHeight = 50; // Graph height in pixels
var sparkMaxWidth = 140; // Max graph width in pixels

//Optimally, you want sparkMaxWidth/sparkGap to return a whole number.

//Spark width is dynamic incase it is unable to get old data if 4
//points are provided and sparkWidth was static, it would stretch
//the graph out, this way the script notices there are only 4 points
//instead of say 20, and scales down the graph width.
var sparkWidth = 1; // Graph width in pixels (sparkSpread*userCount.length) CHANGING THIS HAS NO EFFECT, OVERWRITTEN BY SCRIPT


var sparkLineColor = "777777";
var sparkLineColor = "AAAAAA";
var sparkLineWidth = "1";

var sparkBackground = "FFFFFF00"; //Pure white (FFFFFF) with no opacity (00), a transparent background.
var sparkLineShade = "0E0E0E";

function getSparkUrl(){
	if(showSpark){
		$('sparkGraph').style.display = "block";
		var temp = userCount.join(",");
		var sparkUrl = "http://chart.apis.google.com/chart?"; //Base
		sparkUrl += "chs=" + sparkWidth + "x" + sparkHeight; //Dimensions
		sparkUrl += "&cht=ls"; //Chart type
		sparkUrl += "&chco=" + sparkLineColor; //Color of the line
		sparkUrl += "&chm=B," + sparkLineShade + ",0,0,0"; //Color of graph below the line, shading.
		sparkUrl += "&chf=bg,s," + sparkBackground; //Color of graph above the line, background.
		sparkUrl += "&chls=" + sparkLineWidth + ",0,0"; //Line thickness, segment length, blank segment length
		var arrMax = findMax(userCount); //Arrr, thar be maximum booty here!
		var arrMin = findMin(userCount); //Alas, thar be minimum booty here. :(
		if(showSparkLabels){
			sparkUrl += "&chg=100,50"
			sparkUrl += "&chxt=y&chxl=0:|"+arrMin+"|"+(arrMin+Math.round((arrMax-arrMin)/2))+"|"+arrMax;
		}
		sparkUrl += "&chds="+arrMin+","+arrMax+"";
		sparkUrl += "&chd=t:" + temp; //Data points
		//sparkUrl += "&chd=t:27,25,25,25,25,27,100,31,25,36,25,25,39,25,31,25,25,25,26,26,25,25,28,25,25,100,28,27,31,25,27,27,29,25,27,26,26,25,26,26,35,33,34,25,26,25,36,25,26,37,33,33,37,37,39,25,25,25,25";
		sendDebug(userCount.join(","));
		sendDebug(sparkUrl);
		return sparkUrl;
	} else { $('sparkGraph').style.display = "none"; return "";}
}
function findMax(searchArray){
	var temp = false;
	for(i = 0; i < searchArray.length; i++){
		if(!temp || searchArray[i] > temp){
			temp = searchArray[i];
		}
	}
	return Math.round(temp);
}
function findMin(searchArray){
	var temp = false;
	for(i = 0; i < searchArray.length; i++){
		if(!temp || searchArray[i] < temp){
			temp = searchArray[i];
		}
	}
	return Math.round(temp);
}
function addUserCount(what){
	//Returns true if the userCount array was changed as a result of this,
	//false if not.
	userCountTemp.push(what);
	
	if(userCountTemp.length >= sparkResolution * sparkGap){
		//Round (sparkResolution * sparkGap) minutes from userCountTemp
		//into one number, then add it to the userCount array.
		var temp = 0;
		for(i = 0; i < userCountTemp.length; i++){
			temp += userCountTemp[i];
		}
		temp = temp/(sparkResolution * sparkGap);
		userCount.push(temp);
		
		//If there are more points than the max width allows, remove the
		//first (oldest) one.
		if(userCount.length > sparkMaxWidth/sparkGap){
			userCount.splice(0,1);
		}
		
		//Clear the userCountTemp array in preparation og more numbers.
		userCountTemp = new Array();
		return true;
	}
	return false;
}
function refreshGraph(){
	sparkWidth = userCount.length * sparkGap;
	if(sparkWidth > sparkMaxWidth){sparkWidth = sparkMaxWidth;}
	$('sparkGraph').src = getSparkUrl();
}