/*
Notes...

Skin can be customized via /Images/skin/ If dimensions of the skin files change 
be sure to update the changes in the skin.css file.

The code is not as good as it could be, but it is significantly better than the
last version.

frontHackContainer and backHackContainer are both needed because of a bug. When
the widget used display:block and display:none to show and hide the back and front
sides, it would sometimes destroy scrollbars, making scroll areas unusable. Changing
this to use visibility:visible and visibility:hidden would no longer destroy the
scrollbars, but would allow for both sides of the widget to appear on whichever
side had the lower z-index. Using the hackContainers, the javascript controls
the z-index of the containers so that the hidden side always has a negative z-index
and the shown side always has a positive one, fixing the problem.


*/
var url = new Array()
//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
var userX, userY;
function load()
{
	
	loadPreferences();		
	showAwesomeStyle();
	
	if(!haltLoadForVanity){
		sendDebug("Load function fired.")
		createEffects();
		setupParts();
		startRequest();
		(function(){startNagAttentionGrab();}).delay(2000);
	}

	
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
	widget.setPreferenceForKey(null,createInstancePreferenceKey("xSize"));
	widget.setPreferenceForKey(null,createInstancePreferenceKey("ySize"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    window.resizeTo(450,325);
	updateListEditor();
    var front = document.getElementById("front");
    var back = document.getElementById("back");
	
    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

//	front.style.display = "none";
//	back.style.display = "block";
	
	front.style.visibility = "hidden";
	back.style.visibility = "visible";
	$('frontHackContainer').style.zIndex = "-1";
	$('backHackContainer').style.zIndex = "200";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
	showAwesomeStyle()
	$('hiddenPref').focus();
	//Without the delay, this line would make a noticeable pause before
	//the transition to the front begins.
	(function(){createNationDisplay()}).delay(10);
	refreshGraph();
	
	var userX = widget.preferenceForKey(createInstancePreferenceKey("xSize"));
	var userY = widget.preferenceForKey(createInstancePreferenceKey("ySize"));
	
    window.resizeTo(userX,userY);
    var front = document.getElementById("front");
    var back = document.getElementById("back");
	
	$('frontHackContainer').style.zIndex = "200";
	$('backHackContainer').style.zIndex = "-100";
	
    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

//    front.style.display="block";
//    back.style.display="none";
	
	front.style.visibility="visible";
	back.style.visibility="hidden";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}



//Resize handle handling haha joke.

function mouseDown(event)
{
    document.addEventListener("mousemove", mouseMove, true);
    document.addEventListener("mouseup", mouseUp, true);

    growboxInset = {x:(window.innerWidth - event.x), y:(window.innerHeight - event.y)};

    event.stopPropagation();
    event.preventDefault();
}

function mouseMove(event)
{
    var x = event.x + growboxInset.x;
    var y = event.y + growboxInset.y;

    if (x < 250) x = 250;
    if (y < 250) y = 250;
	userX = x
	userY = y
    // set the attributes for the front of the widget
    document.getElementById("front").style.width = x;
    document.getElementById("front").style.height = y;

    // set the attributes for the inner contents div, minus 
    // the width of the border
    //document.getElementById("inner_contents").style.width = x-40;
    //document.getElementById("inner_contents").style.height = y-40;

    // resize the main widget window
    window.resizeTo(x,y);

    event.stopPropagation();
    event.preventDefault();
	gNationScrollArea.refresh();
}

function mouseUp(event)
{
    document.removeEventListener("mousemove", mouseMove, true);
    document.removeEventListener("mouseup", mouseUp, true); 

    event.stopPropagation();
    event.preventDefault();
	
	var x = event.x + growboxInset.x;
    var y = event.y + growboxInset.y;

    if (x < 250) x = 250;
    if (y < 250) y = 250;
	
	widget.setPreferenceForKey(x,createInstancePreferenceKey("xSize"));
	widget.setPreferenceForKey(y,createInstancePreferenceKey("ySize"));
}


var gNationScrollArea, gNationScrollBar;
var gLeScrollBar, gLeScrollArea;
function setupScrolling(){
	
}